import os
import sys
import os.path
import socket
from socket_communication import socket_secure_send, socket_secure_recv
from socket_communication import SecureCommunication
import database_connection as dc
import database_query as dq

"""
Tries to switch data with another node.
The other node should answer:
YAHPLSGET:,name, file, AEShex, IVhex, RSApubkey, digest
where file is the name it will be served as, when requested by (RSApubkey +) 'name'
digest is the proof that the node has the RSAprivkey
digest should be over name + file + data + AEShex + IVhex

if len(sys.argv) != 3:
    print('Usage:')
    print('')
    print('python3 swicharoo.py datafilepath ip port')

    exit()
"""


def accept_swicharoo(filesize):
    return filesize < 1024 * 1024 * 5  # accept 5MB files


# Helper for sending away information + data
def swicharoo_send(sc, name, my_rsa_pub_key):
    filename = dq.get_originalfilename_from_data(name, my_rsa_pub_key)
    if filename is None:
        print('Could not find data for name, rsa =', name, my_rsa_pub_key)
        return
    # if so, open file to send, read it
    filesize = os.stat(filename).st_size

    # make a digest(filename, filesize, IP:PORT list, timestamp)  # IP:PORT list should be in json format: {"123.0.0.1": "8080", "180.0.0.1": "8081" } ...
    # todo: !!
    
    # send filename, filesize, IP:PORT list, timestamp, digest
    query = filename + b',' + filesize + b',' + 'IP.....'   # Encode to b'...'
    
    # send file

    # insert info in database for who is this other that is keeping a finger for us


def swicharoo_recv():
    # recv information about the file (filename, filesize, IP:PORT list, timestamp, digest, )

    # recv the file

    # verify that the digest(filename, filesize, IP:PORT list, timestamp) is correct vs the RSApubkey or bail out

    # store the file in /data/

    # store the information in the DB (table 'data'), like a classic link (insert_data with their RSAPubkey)
    pass
    
def update_swicharoo(sc):  # use this function when you add IP:PORT data to a data
    # make digest(filename, IP:PORT list)
    
    # Ask for 'NEW_IPLIST'
    
    # Send my RSA_PUB_KEY + filename (these two identifies the actual file) + IP:PORT list + digest 
    
    pass




# Queries the target node if it wants to do a swicharoo, and if so, does it.
def try_swicharoo(filenamepath, ip, port, other_node_rsa_pub_key):
    if os.path.isfile(filenamepath) is not True:  # Check the .aes file exists
        print('File does not exist:', filenamepath)
        return -8
    filesize = os.stat(filenamepath).st_size

    sc = SecureCommunication(ip, port, other_node_rsa_pub_key)  # rsa_pub here is the one linked to the other NODE, not the data
    if sc.is_active():

        # connect and ask other node if it wants to make a swicharoo
        # First query: QUERYNAME + FileSize -> answer NO or
        lengthdata = pack('>Q', filesize)
        query = b'SWICHAROO?' + lengthdata   #     (to_read, ) = unpack('>Q', tmp)  -> seesocket_communication::287
        print('Send query:', query)

        message = sc.send(query)
        answer = message[:10]
        data = message[10:]
        if answer is not None:  # Got answer
            if answer != b'YES_PLEASE':
                print('Swicharoo got rejected')
            else:
                # Now extract name, filename, filesize, timestamp from the data (later also digest?)
                tmp = data.split(b',')
                if len(tmp) == 4:
                    name = tmp[0]
                    filename = tmp[1]
                    filesize = tmp[2]
                    timestamp = tmp[3]

                    # todo: Get the data and insert it into the database
                    #
                    # todo: save it to disk
                    #
                    # todo: send away our data now
                    #
                    # todo: update our tenfingers (as we were able to store our data on another node)

                else:
                    print('The swicharoo answer was malformed')

    return 0



# Test case:
def test():
    pass  # We need a stable setup (or at least one more complicated than todays) to test this


print_information = False

if len(sys.argv) == 2:
    if sys.argv[1] == '--testrun':
        test()
    else:
        print_information = True
else:
    if len(sys.argv) == 3:
        swicharoo(sys.argv[1], sys.argv[2], sys.argv[3])
    else:
        print_information = True

if print_information:
    print('Usage:')
    print('')
    print('python3 swicharoo.py filenamepath, ip, port, other_node_rsa_pub_key')
    print('where filenamepath is the .aes file')
    print('ip:port are the other nodes ip:port')
    print('and the RSA key ... todo use some sort of ID instead of ip, port & rsa key')




